
' x3dgenerator
' for hexadome
'
' Charles E V Pegge
' 15:18 24/08/2007


'----------------------------------------------------|
function main()                                      |
'----------------------------------------------------|
  iquotes [ ]                                        | for use with $ output statements
  new cr=chr 13+chr 10,qu=chr 34                     | string delimiters
                                                     |
  out(o2,"")                                         | switch $ output to this file
  new de     = alphadate(date()), ti=time()          | date and time stamp
  new datafile=Command                               | get the console command line parameter
  new design = getData(datafile+".data")             | get the parameters for the design
  if design EQ "" then "no design found"?; return 0  | give up if no design is not found
  new o2     = output (datafile+".x3d"); out(o2,"")  | x3d script output
                                                     |
'----------------------------------------------------|
  include "script/header"                         | x3d script header
'----------------------------------------------------|
                                                     |
  $ <Scene>                                          | start of main body of x3d script
                                                     |
'----------------------------------------------------|
  include "script/scenery"                           | background and incidentals
'----------------------------------------------------|
                                                     |
                                                     |
'----------------------------------------------------| 
  new fmat   = design.materials.wood.appearance      | extract frame appearance details
  new cmat   = design.materials.aluminium.appearance | extract cladding appearance details
  new fphy   = design.materials.frame.physical       | extract frame physical details
  new geo    = design.geometry                       | extract the geometry section
'----------------------------------------------------| 
' LOAD IN DESIGN SETTINGS                            |
'----------------------------------------------------| 
  new n      = geo.bases                             | n is normally 6
  new nf     = geo.tiers.faces.count                 | number of frames making base //20
  new nt     = geo.tiers.count                       | number of tiers incl turret?? // 6
  new mx     = n*2                                   | ??
  new wi     = geo.batten.width                      | width of planks to be used in mm
  new th     = geo.batten.thickness                  | plank thickness in mm
  new ra     = geo.frame.width / 2                   | radius in metres
'  new vs     = geo.frame.height                     | overall internal height of frame
  new hs     = geo.frame.width / 2                   | overall internal width of frame
  new sx     = geo.scale.x                           | x scale factor
  new sy     = geo.scale.y                           | y scale factor
  new sz     = geo.scale.z                           | z scale factor
  new ma1    = fmat.texture.type                     | texture to represent material 
  new im     = fmat.texture.image                    | inage used for the texture
  new clad   = geo.clad                              | the frame is clad
  new redu   = 1                                     | n/2 panel reduction
  new turret = geo.turret                            | trurret at top of dome
  new cap    = geo.cap                               | apex cap
  new stages = geo.stages                            | dome stages
  new double = 0.0                                   | double frame inner layer eg 0 or 0.95 for 5% smaller inner
'----------------------------------------------------|
  new sc     = 50                                    | model scaling factor for data output
  new su     = "mm"                                  | model scaling units
'----------------------------------------------------| 

':testing1

'new a="1",f="face",c="clad"
'geo.tiers.faces.[f][a].[c]="GLASS"

':testing2

'geo.tiers.faces.[f][a].[c]?

':testing3                                           | createStrutFrame()
                                                     |
'----------------------------------------------------| 
  new la     = 0                                     | layer counter 
  new fm     = 1                                     | 0 for panel 1 for frame
  new lap    = 0                                     | members overlap
  new ap     = 0                                     | apex enlargement ??
  new ssl    = geo.frame.start_slope                 | starting slope degrees
  new esl    = geo.frame.end_slope                   | end slop degrees
  new si     = ( ssl - esl ) / nt                    | slope deccrement
  new hp     = tand( si / 2) *3.0 * (ra-ap)          | panel length factor
  new ovl    = 1.0                                   | overlap oversize factor
'----------------------------------------------------|
                                                     |
  new o3     = output (datafile+".txt")              | output for the dimensianal specs
  out (o3,"")                                        | set $ output for this file
  out (o3,"Frame"+cr)                                |
  $                                                  |
  $ Batten Width:     [wi] m                         |
  $ Batten thickness: [th] m                         |
  $ Radius            [ra] m                         |
  $ Frames at base    [nf]                           |
  $ Number of tiers   [nt]                           |
  $ Start Angle       [ssl]                          |
  $ End Angle         [esl]                          |
  $ Turret            [turret]                       |
  $ Cap               [cap]                          |
  $                                                  |
  if sc NE 1                                         |
  $ Data for model: scaler [sc] units [su]           | 
  end if                                             |
  $ -----------------------------------              | 
  out (o2,"")                                        | switch back to x3d output
'----------------------------------------------------|
                                                     |
  new cr     = chr 13+chr 10                         | crlf for end of lines
  new anim   = 0                                     | animation mode 1 rotation etc 2 for flying panels
  new trc    = 0                                     | ??
  new i      = 0                                     | ??
                                                     |
  out (o2,"")                                        | switch to x3d output
'----------------------------------------------------|
                                                     |
  $<Transform DEF='TRANS' scale="[sx] [sy] [sz]" >   | this is the top level transform for the frame
  if anim                                            |
  $ <TouchSensor DEF='TOUCH'/>                       | this is used to detect mouse click on the frame
  end if                                             |
'----------------------------------------------------|
  new pi=atan(1)*4                                   |
  new hti=0                                          |
  new hts=0                                          | elevation for each panel
  new pra=ra                                         |
  new prf=nf                                         |
  new stu=1                                          |
  new ska=0                                          |
  new pbs=0                                          |
'----------------------------------------------------|
 {                                                   |
  numbers("0")                                       |
  $ <Group DEF="shell[stu]">                         | name for the frame
                                                     |
  createPolyframe( _                                 |
  "polyframe",_     | name                           |
  6,_               | polygon factor                 |
  ra,_              | radius                         |
  wi,_              | member width                   |
  th,_              | member thickness               |
  fm,_              | 1 to render frame              |
  lap,_             | face overlap                   |
  nf,_              | number of frames at base       |
  nt,_              | number of tiers                |
  ssl,_             | start slope angle              |
  si,_              | slope decrement                |
  hp,_              | half panel height for base     |
  0,_               | overlap                        |
  ma1,_             | materialto be used             |
  im _              | image for material texture     |
  )                                                  |
  $ </Group>                                         |
                                                     |
'----------------------------------------------------|
  if clad                                            | Cladding
                                                     |
  hti=pbs                                            | reset base
                                                     |
  $ <Transform scale="1.01 1.01 1.01">               |
                                                     |
  createPolyframe( _                                 |
  "polyframe",_     | name                           |
  6,_               | polygon factor                 |
  ra,_              | radius                         |
  wi,_              | member width                   |
  th,_              | member thickness               |
  0,_               | fm: 0 to render panel          |
  lap,_             | face overlap                   |
  nf,_              | number of frames at base       |
  nt,_              | number of tiers                |
  ssl,_             | start slope angle              |
  si,_              | slope decrement                |
  hp,_              | half panel height for base     |
  ovl,_             | overlap                        |
  "glass",_         | materialto be used             |
  ""_               | image for material texture     |
  )                                                  |
                                                     |
  $ </Transform>                                     |
                                                     |
  end if                                             |
'----------------------------------------------------|
                                                     |
  if double                                          | double frame
                                                     | create inner frame
  numbers("")                                        |
  $ <Transform                                       |
  $ scale=" [double] [double] [double]"><Group       | this is done by scaling down so it's not accurate
  $ USE="shell[stu]"/>                               |
  $ </Transform>                                     |
                                                     |
  end if                                             |
                                                     |
'----------------------------------------------------|
 Extra Structure                                     |
'----------------------------------------------------|
 stu++; if stu LE stages then                        | add new statage: - a dome on the the dome
  if frac(nt/2) EQ 0 then ska=pi/nf                  | rotation offset for additional structure
  ssl-=(nt-1*si);nt=3;nf/=2                          | new settings
  ra=pra                                             | adjust radius to previous radial
  hp = tand( si / 2) *3.0 * (ra-ap)                  |
  hti+=hts                                           | adjust height to previous
  pbs=hti                                            | the the base for the second structure
  turret=0                                           |
  cap=1                                              |
 repeat                                              |
 end if                                              |
                                                     |
 }                                                   | repeat calls
                                                     |
                                                     |
  $</Transform>                                      |
                                                     |
                                                     |
  include "script/x3danim"                           |
                                                     |
  $</Scene>                                          |
  $</X3D>                                            |
                                                     |
  close o2;close o3;return 0                         |
                                                     |
end function                                         |
'----------------------------------------------------|




'----------------------------------------------------|
function getData(fi)                                 |
'----------------------------------------------------|
 new io=file(fi), d=get(io,100000)                   |
 close io; return d                                  |
end function                                         |
'----------------------------------------------------|




'----------------------------------------------------|
function alphadate(dt)                               |
'----------------------------------------------------|
                                                     |
 return mid("__JanFebMarAprMayJunJulAugSepOctNovDec",_
 val(mid(dt,1,2))*3,3)+mid(dt,3,8)                   |
                                                     |
end function                                         |
'----------------------------------------------------|




'----------------------------------------------------|
                                                     |
include "script/x3dPolyframe"                        |
                                                     |
'----------------------------------------------------|

